'''Projet : Python Racing©, un jeu de course fait avec tkinter'''
'''Tous droits réservés aux deux développeurs de Python Racing© : Mohamed Anouassi et Martynas Bou-Jabbour (1è3)'''

#module importé :
from tkinter import*

#création du menu de jeu
def menu():
    '''la fonction menu crée le menu du jeu'''
    #fenêtre du menu avec une image de fond
    menu= Tk()
    menu.title("Python Racing©")
    menu.config(bg="#87CEEB")
    menu.geometry("1440x900")
    can=Canvas(menu, width=1440, height=900)
    img=PhotoImage(file="course.gif")
    can.create_image(0, 0, anchor=NW, image=img)
    can.place(x=0, y=0)

    #titre du jeu
    titre =Label(menu, text = "Python Racing©",font=("Courrier",30))
    titre.pack()
    #mot "vitesse" situé au-dessus des réglages de vitesse
    texte_vit =Label(menu, text = "Vitesse")
    texte_vit.pack()

    #variables modifiables (vitesse, couleur et nom des joueurs) dans des listes, valeurs par défaut
    vit=[75]
    colors=["red","blue"]
    pseudos=["Joueur 1","Joueur 2"]
    #enregistrement des scores
    scores=[0,0]


    def resetvictoire():
        '''la fonction resetvictoire réinitialise les scores de la liste'''
        scores[0]=0
        scores[1]=0

    #création d'un bouton qui réinitialise les scores des parties
    button_resetvic = Button (menu, text = "Réinitialiser le compteur de victoires ?", command=resetvictoire, cursor="target", relief=GROOVE)
    button_resetvic.place(x=655,y=400)



    def enregistrer_p1(événement):
        '''la fonction enregistrer_p1 permet d'enregistrer un pseudo personnel pour le joueur 1 avec message de validation'''
        pseudos[0]=entrée1.get()
        validation1['text'] = "Vous avez sélectionné : {}".format(pseudos[0])

    #création de la barre de saisie pour enregistrer le pseudo du joueur 1
    value=StringVar(menu)
    value.set("Joueur 1")
    entrée1  = Entry (menu, textvariable=value)
    entrée1.place(x=100,y=40)
    entrée1.bind("<Return>",enregistrer_p1)

    #affichage d'informations pour le joueur 1 (Entrée pour validation du pseudo saisi, message de validation et clic utilisé pour avancer)
    info_entree = Label (menu, text = "Appuyez sur Entrée pour valider un pseudo dans la barre de saisie")
    info_entree.place(x=105,y=65)
    clic = Label (menu, text = "Joueur 1 : utilisez le clic GAUCHE de la souris pour avancer")
    clic.place(x=105,y=210)
    validation1 = Label (menu, text= "Joueur 1")
    validation1.place(x=100, y=15)



    def enregistrer_p2(événement):
        '''la fonction enregistrer_p2 permet d'enregistrer un pseudo personnel pour le joueur 2 avec message de validation'''
        pseudos[1]=entrée2.get()
        validation2['text'] = "Vous avez sélectionné : {}".format(pseudos[1])


    #création de la barre de saisie pour enregistrer le pseudo du joueur 2
    value=StringVar(menu)
    value.set("Joueur 2")
    entrée2  = Entry (menu, textvariable=value)
    entrée2.place(x=1000,y=40)
    entrée2.bind("<Return>",enregistrer_p2)
    validation2 = Label (menu, text= "Joueur 2")
    validation2.place(x=1000, y=15)

    #affichage d'informations pour le joueur 2 (Entrée pour validation du pseudo saisi, message de validation et clic utilisé pour avancer)
    info_entree2 = Label (menu, text = "Appuyez sur Entrée pour valider un pseudo dans la barre de saisie")
    info_entree2.place(x=1005,y=65)
    clic2 = Label (menu, text = "Joueur 2 : utilisez le clic DROIT de la souris pour avancer")
    clic2.place(x=1005,y=210)


    def color1():
        '''la fonction color1 permet de modifier la couleur du joueur 1 selon le bouton radio choisi (rouge par défaut)'''
        if var.get()==1:
            colors[0]="red"
        if var.get()==2:
            colors[0]="green"
        if var.get()==3:
            colors[0]="blue"

    def color2():
        '''la fonction color2 permet de modifier la couleur du joueur 2 selon le bouton radio choisi (bleu par défaut)'''
        if var1.get()==1:
            colors[1]="red"
        if var1.get()==2:
            colors[1]="green"
        if var1.get()==3:
            colors[1]="blue"

    #création des boutons radio permettant de choisir la couleur pour chaque joueur
    var=IntVar()
    var1=IntVar()
    red1=Radiobutton(menu,text="Rouge",variable=var,value=1, command=color1)

    green1=Radiobutton(menu,text="Vert",variable=var,value=2, command=color1)

    blue1=Radiobutton(menu,text="Bleu",variable=var,value=3, command=color1)

    red2=Radiobutton(menu,text="Rouge",variable=var1,value=1, command=color2)

    green2=Radiobutton(menu,text="Vert",variable=var1,value=2, command=color2)

    blue2=Radiobutton(menu,text="Bleu",variable=var1,value=3, command=color2)

    red1.place(x=105,y=100)

    green1.place(x=105,y=140)

    blue1.place(x=105,y=180)

    red2.place(x=1005,y=100)

    green2.place(x=1005,y=140)

    blue2.place(x=1005,y=180)


    def speed():
        '''la fonction speed permet de modifier la vitesse des joueurs dans la course selon le bouton radio choisi (moyen par défaut)'''
        if var2.get()=="1":
            vit[0]=30
        if var2.get()=="2":
            vit[0]=75
        if var2.get()=="3":
            vit[0]=110

    #création des boutons radio permettant de choisir la vitesse des joueurs
    var2 = StringVar(menu, "2")
    values={"Lent " : "1","Moyen " : "2","Rapide":"3"}
    for (text, value) in values.items():
        Radiobutton(menu, text = text, variable = var2,
        value = value, command=speed).pack(side = TOP, ipady = 3)


    def fenetreTuto():
        '''la fonction fenetreTuto permet d'afficher une fenêtre avec un texte expliquant le jeu en cliquant sur un bouton'''
        NouvelleFenetre=Tk()
        NouvelleFenetre.title("Tutoriel")
        text1=Button(NouvelleFenetre, text="Python Racing© est un jeu de course de voitures entre deux joueurs")
        text1.pack()
        text2=Button(NouvelleFenetre, text="Le but du jeu est d'atteindre la ligne d'arrivée le premier en appuyant rapidement et de manière répétée le bouton de la souris correspondant pour faire avancer sa voiture (joueur un a le clic gauche et joueur deux le clic droit).")
        text2.pack()
        text3=Button(NouvelleFenetre, text="Vous pouvez personnaliser votre voiture dans le menu avant une partie. Bonne course!")
        text3.pack()

    #création du bouton affichant le tutoriel du jeu
    btn_tuto=Button(menu, text="Tutoriel", command= fenetreTuto, cursor="heart", relief=GROOVE)
    btn_tuto.pack()

#création de la fenêtre de jeu
    def logijeu():
        '''la fonction logijeu crée la fenêtre de jeu'''

        fenetre = Tk()

        #mettre le jeu en plein écran
        fenetre.overrideredirect(1)



        #création d'un canvas

        canvas = Canvas(fenetre, width=10000, height=8000, background='gray74')
        canvas.pack()


        def compteur(remaining_time):
            '''la fonction compteur permet d'afficher un compteur de 5 secondes avant le début de la course pour la préparation éventuelle des joueurs, qui ensuite disparaît'''
            remaining_time -= 1
            count['text'] = "Début dans : {}".format(remaining_time)
            if remaining_time > 0:
                count.after(1000, compteur, remaining_time)
            elif remaining_time==0:
                count['text'] = "Go !"
                commencer[0]=1
                count.after(1000, compteur, remaining_time)
            else:
                canvas.delete(fenetre_compteur)

        #création de l'espace du compteur sur le canvas
        count = Label(fenetre, text="Début dans : 5", font=("Courrier", 30), fg='green', background='gray74')
        count.pack(side=RIGHT)
        #attente pour l'exécution de la fonction compteur
        count.after(1000, compteur, 5)
        fenetre_compteur = canvas.create_window(700, 400, window=count)

        #création des deux joueurs voitures(avec leurs éléments respectifs : roues et vitres), leurs pseudos et la ligne d'arrivée

        joueurun = canvas.create_rectangle(60,50,140,120,fill=colors[0])
        roue11 = canvas.create_rectangle(50,100,80,130,fill="black")
        roue12 = canvas.create_rectangle(120,100,150,130,fill="black")
        vitre1 = canvas.create_rectangle(110,60,140,90,fill="white")

        joueurdeux = canvas.create_rectangle(60,330,140,400,fill=colors[1])
        roue21 = canvas.create_rectangle(50,380,80,410,fill="black")
        roue22 = canvas.create_rectangle(120,380,150,410,fill="black")
        vitre2 = canvas.create_rectangle(110,340,140,370,fill="white")

        limite = canvas.create_rectangle(1300,0,1320,1000,fill="black")

        nomun = canvas.create_text(80,20,text=pseudos[0], font=("Arial 16 italic",10), fill="black")
        nomdeux = canvas.create_text(80,300,text=pseudos[1], font=("Arial 16 italic",10), fill="black")

        #détecteur de victoire qui se réinitialise après une partie
        vict=[0,0]
        #détecteur de commencement de course
        commencer=[0]



        def actionun(mo):
            """la fonction actionun définit le déplacement du joueur un dans la course"""
            #conditions du déplacement du joueur un et de son pseudo: si aucun des joueurs n'est sur la ligne d'arrivée
            if canvas.coords(joueurun)[2]<1300 and canvas.coords(joueurdeux)[2]<1300 and commencer[0]==1:
                canvas.move(joueurun,vit[0],0)
                canvas.move(nomun,vit[0],0)
                canvas.move(roue11,vit[0],0)
                canvas.move(roue12,vit[0],0)
                canvas.move(vitre1,vit[0],0)
            #affichage de l'écran de victoire pour le joueur un s'il gagne la course (et suppression des éléments du jeu)
            if canvas.coords(joueurun)[2]>=1300:
                scores[0]+=1
                vict[0]+=1
                txt1 = canvas.create_text(700,400,text=pseudos[0] +" a gagné : {} à {}".format(scores[0],scores[1]), font=("Arial 16 italic",50), fill="green")
                txt3 = canvas.create_text(700,600,text="Rejouer ? Taper 'o' pour recommencer,'n' pour arrêter",font=("Arial 16 italic",30),fill="blue")
                canvas.delete(joueurun)
                canvas.delete(joueurdeux)
                canvas.delete(nomun)
                canvas.delete(nomdeux)
                canvas.delete(roue11)
                canvas.delete(roue12)
                canvas.delete(vitre1)
                canvas.delete(roue21)
                canvas.delete(roue22)
                canvas.delete(vitre2)

        def actiondeux(mo):
            """la fonction actionun définit le déplacement du joueur deux dans la course"""

            #conditions du déplacement du joueur deux et son pseudo: si aucun des joueurs n'est sur la ligne d'arrivée

            if canvas.coords(joueurdeux)[2]<1300 and canvas.coords(joueurun)[2]<1300 and commencer[0]==1:
                canvas.move(joueurdeux,vit[0],0)
                canvas.move(nomdeux,vit[0],0)
                canvas.move(roue21,vit[0],0)
                canvas.move(roue22,vit[0],0)
                canvas.move(vitre2,vit[0],0)

            #affichage de l'écran de victoire pour le joueur deux s'il gagne la course (et suppression des éléments du jeu)

            if canvas.coords(joueurdeux)[2]>=1300:
                scores[1]+=1
                vict[1]+=1
                txt2 = canvas.create_text(700,400,text=pseudos[1] + " a gagné : {} à {}".format(scores[1],scores[0]), font=("Arial 16 italic",50), fill="green")
                txt4 = canvas.create_text(700,600,text="Rejouer ? Taper 'o' pour recommencer,'n' pour arrêter",font=("Arial 16 italic",30),fill="blue")
                canvas.delete(joueurun)
                canvas.delete(joueurdeux)
                canvas.delete(nomun)
                canvas.delete(nomdeux)
                canvas.delete(roue11)
                canvas.delete(roue12)
                canvas.delete(vitre1)
                canvas.delete(roue21)
                canvas.delete(roue22)
                canvas.delete(vitre2)

        def restart(mo):
            '''la fonction restart permet en cas de victoire de quitter la fenêtre en appuyant sur 'n' pour arrêter ou d'en ouvrir une nouvelle en appuyant sur 'o' (en supprimant l'ancienne) pour recommencer'''
            touche = mo.keysym
            if vict[0]>0 or vict[1]>0:
                if touche=="o":
                    fenetre.destroy()
                    logijeu()
                if touche=="n":
                    fenetre.destroy()


        #on exécute la fonction actionun si le clic gauche de la souris est relâché (pas de possibilité de maintenir appuyé le bouton pour avancer plus rapidement)
        fenetre.bind("<ButtonRelease-1>",actionun)
        #on exécute la fonction actiondeux si le clic droit de la souris est relâché (pas de possibilité de maintenir appuyé le bouton pour avancer plus rapidement)
        fenetre.bind("<ButtonRelease-3>",actiondeux)
#on exécute la fonction restart en appuyant sur un bouton du clavier
        fenetre.bind("<KeyPress>",restart)

        fenetre.mainloop()


    #la condition KeyRelease ne marche pas sur tous les ordinateurs donc la souris remplace les touches de clavier

    #bouton pour commencer une partie
    bouton_jeu=Button(menu, text="Commencer une partie", command=logijeu, cursor="star", height= 5, width=20, relief=GROOVE)
    bouton_jeu.pack()

    menu.mainloop()



#lancement du menu du jeu lors de l'exécution du programme
menu()








